import { default as default_2 } from 'react';
import { GraphiQLProvider } from '@graphiql/react';
import { GraphiQLProviderProps } from '@graphiql/react';
import { PropsWithChildren } from 'react';
import { ReactNode } from 'react';
import { UseHeaderEditorArgs } from '@graphiql/react';
import { UseQueryEditorArgs } from '@graphiql/react';
import { UseResponseEditorArgs } from '@graphiql/react';
import { UseVariableEditorArgs } from '@graphiql/react';
import { WriteableEditorProps } from '@graphiql/react';

declare type AddSuffix<Obj extends Record<string, any>, Suffix extends string> = {
    [Key in keyof Obj as `${string & Key}${Suffix}`]: Obj[Key];
};

declare function GraphiQL({ dangerouslyAssumeSchemaIsValid, defaultQuery, defaultTabs, externalFragments, fetcher, getDefaultFieldNames, headers, inputValueDeprecation, introspectionQueryName, maxHistoryLength, onEditOperationName, onSchemaChange, onTabChange, onTogglePluginVisibility, operationName, plugins, query, response, schema, schemaDescription, shouldPersistHeaders, storage, validationRules, variables, visiblePlugin, defaultHeaders, ...props }: GraphiQLProps): default_2.JSX.Element;

declare namespace GraphiQL {
    var Logo: typeof GraphiQLLogo;
    var Toolbar: typeof GraphiQLToolbar;
    var Footer: typeof GraphiQLFooter;
}
export { GraphiQL }
export default GraphiQL;

declare function GraphiQLFooter<TProps>(props: PropsWithChildren<TProps>): default_2.JSX.Element;

declare namespace GraphiQLFooter {
    var displayName: string;
}

export declare function GraphiQLInterface(props: GraphiQLInterfaceProps): default_2.JSX.Element;

export declare type GraphiQLInterfaceProps = WriteableEditorProps & AddSuffix<Pick<UseQueryEditorArgs, 'onEdit'>, 'Query'> & Pick<UseQueryEditorArgs, 'onCopyQuery'> & AddSuffix<Pick<UseVariableEditorArgs, 'onEdit'>, 'Variables'> & AddSuffix<Pick<UseHeaderEditorArgs, 'onEdit'>, 'Headers'> & Pick<UseResponseEditorArgs, 'responseTooltip'> & {
    children?: ReactNode;
    defaultEditorToolsVisibility?: boolean | 'variables' | 'headers';
    isHeadersEditorEnabled?: boolean;
    toolbar?: GraphiQLToolbarConfig;
    showPersistHeadersSettings?: boolean;
    forcedTheme?: (typeof THEMES)[number];
    className?: string;
};

declare function GraphiQLLogo<TProps>(props: PropsWithChildren<TProps>): default_2.JSX.Element;

declare namespace GraphiQLLogo {
    var displayName: string;
}

export declare type GraphiQLProps = Omit<GraphiQLProviderProps, 'children'> & GraphiQLInterfaceProps;

export { GraphiQLProvider }

export { GraphiQLProviderProps }

declare function GraphiQLToolbar<TProps>(props: PropsWithChildren<TProps>): default_2.JSX.Element;

declare namespace GraphiQLToolbar {
    var displayName: string;
}

declare type GraphiQLToolbarConfig = {
    additionalContent?: default_2.ReactNode;
    additionalComponent?: default_2.JSXElementConstructor<any>;
};

declare const THEMES: readonly ["light", "dark", "system"];

export { }


export declare namespace GraphiQL {
    var Logo: typeof GraphiQLLogo;
    var Toolbar: typeof GraphiQLToolbar;
    var Footer: typeof GraphiQLFooter;
}


declare namespace GraphiQLLogo {
    var displayName: string;
}


declare namespace GraphiQLToolbar {
    var displayName: string;
}


declare namespace GraphiQLFooter {
    var displayName: string;
}

